package cn.iocoder.yudao.module.tkdata.service.employeebigbrother;

import java.util.*;
import javax.validation.*;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.tkdata.controller.admin.employeebigbrother.vo.EmployeeBigBrotherPageReqVO;
import cn.iocoder.yudao.module.tkdata.controller.admin.employeebigbrother.vo.EmployeeBigBrotherSaveReqVO;
import cn.iocoder.yudao.module.tkdata.controller.admin.employeehosts.vo.CompletedRateVO;
import cn.iocoder.yudao.module.tkdata.dal.dataobject.employeebigbrother.EmployeeBigBrotherDO;
import org.apache.ibatis.annotations.Param;


/**
 * 大哥数据员工业务 Service 接口
 *
 * @author ziin
 */
public interface EmployeeBigBrotherService {

    /**
     * 创建大哥数据员工业务
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createEmployeeBigBrother(@Valid EmployeeBigBrotherSaveReqVO createReqVO);

    /**
     * 更新大哥数据员工业务
     *
     * @param updateReqVO 更新信息
     */
    void updateEmployeeBigBrother( EmployeeBigBrotherSaveReqVO updateReqVO);

    /**
     * 删除大哥数据员工业务
     *
     * @param id 编号
     */
    void deleteEmployeeBigBrother(Integer id);

    /**
    * 批量删除大哥数据员工业务
    *
    * @param ids 编号
    */
    void deleteEmployeeBigBrotherListByIds(List<Integer> ids);

    /**
     * 获得大哥数据员工业务
     *
     * @param id 编号
     * @return 大哥数据员工业务
     */
    EmployeeBigBrotherDO getEmployeeBigBrother(Integer id);

    /**
     * 获得大哥数据员工业务分页
     *
     * @param pageReqVO 分页查询
     * @return 大哥数据员工业务分页
     */
    PageResult<EmployeeBigBrotherDO> getEmployeeBigBrotherPage(EmployeeBigBrotherPageReqVO pageReqVO);

    Boolean allocationEmployeeBigBrother(@Valid List<EmployeeBigBrotherSaveReqVO> createReqVO);

    PageResult<EmployeeBigBrotherDO> getEmployeeBigBrotherPageWithSelf(@Valid EmployeeBigBrotherPageReqVO pageReqVO);

    void batchUpdateEmployeeBigBrother(@Valid List<EmployeeBigBrotherSaveReqVO> updateReqVO);

    List<CompletedRateVO> getEmployeeBrotherCompleteBarChart(@Param("list") List<Long> list, @Param("days") Integer days);

    CompletedRateVO getEmployeeHostsCompleteWithSelf(Long loginUserId);
}